﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class EnemyMgr : MonoBehaviour {
   
    public static EnemyMgr Instance;

    public float spawnTime = 0;
    public float spawnTimeDecrease = 0;
    public float maxEnemies;
    public Text scoreText;
    float score;
    float timeToSpawn = 0;
    public GameObject player;
    public GameObject defaultEnemy;
    List<GameObject> enemies;

    public Transform[] SpawnLocations;

	// Use this for initialization
	void Start () {
        Instance = this;
        enemies = new List<GameObject>();
	}
	
	// Update is called once per frame
	void Update () {
        timeToSpawn -= Time.deltaTime;
        if (enemies.Count < maxEnemies && timeToSpawn <= 0)
        {
            SpawnEnemy();
            spawnTime = Mathf.Max(0, spawnTime-spawnTimeDecrease);
            timeToSpawn = spawnTime;
        }
	}

    public void SpawnEnemy()
    {
        Transform spawnLoc = SpawnLocations[Random.Range(0, SpawnLocations.Length)];
        GameObject newEnemy = Instantiate(defaultEnemy) as GameObject;
        newEnemy.transform.position = spawnLoc.position;
        newEnemy.GetComponent<EnemyAI>().target = player;
        enemies.Add(newEnemy);
    }

    public void RemoveEnemy(GameObject enemy, bool killed = false)
    {
        
        if (killed)
        {
            score++;
            scoreText.text = "Score: " + score;
            enemy.GetComponent<EnemyAI>().OnDeath();
        }
        enemies.Remove(enemy);
        Destroy(enemy);
    }
}
