﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

[RequireComponent (typeof(MovementAnimation))]
public class FireGun : MonoBehaviour {
    
    public GameObject bullet;
    public int ammo;
    public Text ammoText;
    bool fired;
    MovementAnimation.direction dir;
    MovementAnimation anim;

    // Use this for initialization
	void Start () {
        anim = GetComponent<MovementAnimation>();
        ammoText.text = "Ammo: " + ammo;
	}
	
	// Update is called once per frame
	void Update () {
	    if (Input.GetAxisRaw("FireGun") > 0 && !fired && ammo > 0)
        {
            fired = true;
            --ammo;
            ammoText.text = "Ammo: " + ammo;
            dir = anim.CurState;
            GameObject newBullet = Instantiate(bullet) as GameObject;
            Vector2 bulletPos = transform.position;
            Vector2 bulletVel = Vector2.zero;
            float zRotation = 0f;
            if (dir == MovementAnimation.direction.kBack)
            {
            bulletPos.y += 0.3f;
            bulletVel.y = 0.05f;
            zRotation = 90f;
            }
            else if (dir == MovementAnimation.direction.kLeft)
            {
            bulletPos.x -= 0.2f;
            bulletVel.x = -0.05f;
            }
            else if (dir == MovementAnimation.direction.kRight)
            {
            bulletPos.x += 0.2f;
            bulletVel.x = 0.05f;
            }
            else
            {
            bulletPos.y -= 0.3f;
            bulletVel.y = -0.05f;
            zRotation = 90f;
            }
            newBullet.transform.position = bulletPos;
            newBullet.GetComponent<Bullet>().SetVelocity(bulletVel);
            newBullet.transform.rotation = Quaternion.AngleAxis(zRotation, Vector3.back);
        }
        else if (Input.GetAxisRaw("FireGun") <= 0)
        {
            fired = false;
        }
	}

    void OnTriggerEnter2D(Collider2D col)
    {
        if (col.gameObject.tag == "Ammo")
        {
            col.gameObject.GetComponent<Ammo>().GiveBullets(this);
            Destroy(col.gameObject);
            ammoText.text = "Ammo: " + ammo;
        }
    }
}
