﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
 
public class PlayerController : MonoBehaviour {
    public float speed;
    MovementAnimation anim;
    public float health;
    public Text healthText;
	// Use this for initialization
	void Start () {
        anim = GetComponent<MovementAnimation>();
        healthText.text = "Health: " + health;
	}
	
	// Update is called once per frame
	void Update () {
        float xMove = Input.GetAxisRaw("Horizontal");
        float yMove = Input.GetAxisRaw("Vertical");

        Vector2     newLoc = transform.position;
        newLoc.x += xMove * speed;
        newLoc.y += yMove * speed;
        transform.position = newLoc;
        
        if (yMove == -1)
            anim.newstate = MovementAnimation.direction.kForward;
        else if (yMove == 1)
            anim.newstate = MovementAnimation.direction.kBack;
        else if (xMove == -1)
            anim.newstate = MovementAnimation.direction.kLeft;
        else if (xMove == 1)
            anim.newstate = MovementAnimation.direction.kRight;
        else
            anim.newstate = MovementAnimation.direction.kIdle;
	}

    
    public void ReduceHealth()
    {
        --health;
        healthText.text = "Health: " + health;
        if (health <= 0)
        {
            Debug.Log("WOW! YOU LOSE!");
        }
    }
}
